Attribute VB_Name = "EndiciaAPI"
Public elsDir As String
Public elsTmpDir As String
Public elsIni As String
Public elsSettingsXml As MSXML2.DOMDocument60
Public elsHttp As MSXML2.ServerXMLHTTP60
Public elsHttp2 As WinHttp.WinHttpRequest
Public elsXmlTrans, elsXmlResponseTxt As String
Public elsResponseXml As MSXML2.DOMDocument60
Public elsLblFormatXmlStr As String

Public elsCustomsWgtUnits, elsCustomsWgtPer, elsCustomsValPer As String

Public elsCustomsQty1, elsCustomsQty2, elsCustomsQty3, elsCustomsQty4, elsCustomsQty5
Public elsCustomsDesc1, elsCustomsDesc2, elsCustomsDesc3, elsCustomsDesc4, elsCustomsDesc5
Public elsCustomsWgt1, elsCustomsWgt2, elsCustomsWgt3, elsCustomsWgt4, elsCustomsWgt5
Public elsCustomsVal1, elsCustomsVal2, elsCustomsVal3, elsCustomsVal4, elsCustomsVal5
Public elsCustomsHts1, elsCustomsHts2, elsCustomsHts3, elsCustomsHts4, elsCustomsHts5
Public elsCustomsOrig1, elsCustomsOrig2, elsCustomsOrig3, elsCustomsOrig4, elsCustomsOrig5
Public elsCustomsSample, elsCustomsDG, elsCustomsDoc, elsCustomsMerch, elsCustomsDonate, elsCustomsReturn, elsCustomsGift, elsCustomsOther
Public elsCustomsOtherDesc
Public elsCustomsCertify
Public elsCustomsCertName

Dim elsStr0 As String, elsStr1 As String, elsStr2 As String, elsStr3 As String, elsStr4 As String, elsStr5 As String
Dim elsNum0 As Variant, elsNum1 As Variant, elsNum2 As Variant, elsNum3 As Variant, elsNum4 As Variant, elsNum5 As Variant
Dim elsFileNum0 As Integer, elsFileNum1 As Integer, elsFileNum2 As Integer


Sub ELS_Initialize()
    Set elsResponseXml = Nothing
    
    elsDir = CS32.ShipDir & "Logic\Endicia"
    
    If Dir(elsDir, vbDirectory) = "" Then
        MkDir elsDir
    End If
    elsDir = elsDir & "\"
        
    If Dir(elsDir & "XML", vbDirectory) = "" Then
        MkDir elsDir & "XML"
    End If
    
    If Dir(elsDir & "Labels", vbDirectory) = "" Then
        MkDir elsDir & "Labels"
    End If
    
    If Dir(RunDir & "ELS", vbDirectory) = "" Then
        MkDir RunDir & "ELS"
    End If
    fErase RunDir & "ELS\ELS-LabelPrint.exe"
    fCopy elsDir & "ELS-LabelPrint.exe", RunDir & "ELS\ELS-LabelPrint.exe"
    
    elsTmpDir = RunDir & "ELS"
    If Dir(elsTmpDir, vbDirectory) = "" Then
        MkDir elsTmpDir
    End If
    elsTmpDir = elsTmpDir & "\"
    
    If Dir(elsTmpDir & "Temp", vbDirectory) = "" Then
        MkDir elsTmpDir & "Temp"
    End If
    
    Set elsSettingsXml = New MSXML2.DOMDocument60
    elsSettingsXml.async = False
    elsSettingsXml.Load (elsDir & "elsconfig.xml")
    
    elsCustomsWgtUnits = IniRead(elsDir & "Els.ini", "Customs Settings", "WeightUnits", "{NOT SET}")
    If elsCustomsWgtUnits = "{NOT SET}" Or (UCase(elsCustomsWgtUnits) <> "OZ" And UCase(elsCustomsWgtUnits) <> "LB") Then
        elsCustomsWgtUnits = "OZ"
        IniWrite elsDir & "Els.ini", "Customs Settings", "WeightUnits", elsCustomsWgtUnits
    End If
    elsCustomsWgtPer = IniRead(elsDir & "Els.ini", "Customs Settings", "WeightPer", "{NOT SET}")
    If elsCustomsWgtPer = "{NOT SET}" Or (UCase(elsCustomsWgtPer) <> "LINE" And UCase(elsCustomsWgtPer) <> "EACH") Then
        elsCustomsWgtPer = "LINE"
        IniWrite elsDir & "Els.ini", "Customs Settings", "WeightPer", elsCustomsWgtPer
    End If
    elsCustomsValPer = IniRead(elsDir & "Els.ini", "Customs Settings", "ValuePer", "{NOT SET}")
    If elsCustomsValPer = "{NOT SET}" Or (UCase(elsCustomsValPer) <> "LINE" And UCase(elsCustomsValPer) <> "EACH") Then
        elsCustomsValPer = "LINE"
        IniWrite elsDir & "Els.ini", "Customs Settings", "ValuePer", elsCustomsValPer
    End If
    
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Merchandise", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Merchandise", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "DG", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "DG", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Documents", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Documents", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Donation", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Donation", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Gift", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Gift", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Return", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Return", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Sample", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Sample", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Other", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Other", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "OtherDesc", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "OtherDesc", ""
    End If

    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Certify", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Certify", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "CertifyName", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "CertifyName", ""
    End If
    
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Qty1", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Qty1", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Desc1", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Desc1", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Weight1", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Weight1", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Value1", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Value1", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "HtsCode1", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "HtsCode1", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "OrigCountry1", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "OrigCountry1", ""
    End If
    
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Qty2", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Qty2", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Desc2", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Desc2", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Weight2", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Weight2", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Value2", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Value2", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "HtsCode2", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "HtsCode2", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "OrigCountry2", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "OrigCountry2", ""
    End If
    
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Qty3", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Qty3", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Desc3", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Desc3", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Weight3", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Weight3", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Value3", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Value3", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "HtsCode3", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "HtsCode3", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "OrigCountry3", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "OrigCountry3", ""
    End If
    
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Qty4", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Qty4", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Desc4", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Desc4", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Weight4", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Weight4", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Value4", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Value4", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "HtsCode4", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "HtsCode4", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "OrigCountry4", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "OrigCountry4", ""
    End If
    
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Qty5", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Qty5", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Desc5", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Desc5", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Weight5", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Weight5", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "Value5", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "Value5", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "HtsCode5", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "HtsCode5", ""
    End If
    XC9 = IniRead(elsDir & "Els.ini", "CustomsDefaults", "OrigCountry5", "{NOT SET}")
    If XC9 = "{NOT SET}" Then
        IniWrite elsDir & "Els.ini", "CustomsDefaults", "OrigCountry5", ""
    End If

    Dim kdvCarrFil As KiDataView
    Set kdvCarrFil = DbfSelect(CS32.ShipDir & "CS_CARR.FIL", "LEFT(INTCODE, 1) = 'X'")
    Do While Not kdvCarrFil.EOF
        XC1 = ELS_GetMailClass(kdvCarrFil("INTCODE"))
        If Not KiEmpty(XC1) Then
            IniWrite CS32.ShipDir & "RTX\RTX.INI", Trim(kdvCarrFil("CARRIER")), "User1", "0.00,Fixed,Flat Fee,0.00,0.00,YES,Print Return Label,NO,NO"
            IniWrite CS32.ShipDir & "RTX\RTX.INI", Trim(kdvCarrFil("CARRIER")), "Collect On Delivery", "0.00,Fixed,Flat Fee,0.00,0.00,YES,COD,NO,NO"
            IniWrite CS32.ShipDir & "RTX\RTX.INI", Trim(kdvCarrFil("CARRIER")), "Declared Value", "0.00,Fixed,Flat Fee,0.00,0.00,YES,Declared Value,NO,NO"
        End If
        
        kdvCarrFil.MoveNext
    Loop
    Set kdvCarrFil = Nothing

    ELS_Cleanup

    'EodTrigger.Start
End Sub

Sub ELS_AfterCarrierLookup()
    Dim elsMailClass As String
    
    elsMailClass = ELS_GetMailClass(CS32.GetVar("xINTCODE"))
    If KiEmpty(elsMailClass) Then
        Exit Sub
    End If

    If Not CS32.GetVar("xUSE_CVD") = "Y" Then
        CS32.SetVar "xUSE_CVD", "N"
    End If
    If Not CS32.GetVar("xUSE_CVP") = "Y" Then
        CS32.SetVar "xUSE_CVP", "N"
    End If
    If Not CS32.GetVar("xUSE_HED") = "Y" Then
        CS32.SetVar "xUSE_HED", "N"
    End If
    If Not CS32.GetVar("xUSE_HEP") = "Y" Then
        CS32.SetVar "xUSE_HEP", "N"
    End If
        
    'Use RATE_CODE so that this only runs once.
    XC1 = Alltrim(CS32.GetVar("xRATE_CODE"))
    If XC1 = "XXXXX" Then
        Exit Sub
    End If
    If KiEmpty(XC1) Then
        CS32.SetVar "xRATE_CODE", "XXXXX"
    End If


    'Set service defaults for all ELS carriers.
    XC1 = "/ELS/CarrierCodeDefaults/CarrierCodeDefault[not (@carrier)]/"
    XN1 = 1

    Do While True
        XC2 = XmlReadXPath(elsSettingsXml, XC1 & "Default[" & Str(XN1) & "]/@csfield")
        If KiEmpty(XC2) Then
            Exit Do
        End If
            
        XC3 = XmlReadXPath(elsSettingsXml, XC1 & "Default[" & Str(XN1) & "]/@csvalue")
        'Debug("Set x" & XC2 & " => " & XC3)
         
        CS32.SetVar "x" & XC2, XC3
        
        XN1 = XN1 + 1
    Loop

    'Set service defaults for current carrier code.
    XC1 = "/ELS/CarrierCodeDefaults/CarrierCodeDefault[@carrier='" & Alltrim(CS32.GetVar("xCARRIER")) & "']/"
    XN1 = 1
    Do While True
        XC2 = XmlReadXPath(elsSettingsXml, XC1 & "Default[" & Str(XN1) & "]/@csfield")
        If KiEmpty(XC2) Then
            Exit Do
        End If
    
        XC3 = XmlReadXPath(elsSettingsXml, XC1 & "Default[" & Str(XN1) & "]/@csvalue")
        'Debug("Set x" & XC2 & " => " & XC3)
    
        CS32.SetVar "x" & XC2, XC3
        
        XN1 = XN1 + 1
    Loop


End Sub

Sub ELS_Rate()
    Dim csIntCode As String
    csIntCode = CS32.GetVar("xINTCODE")
    
    elsMailClass = ELS_GetMailClass(csIntCode)
    If KiEmpty(elsMailClass) Then
        Exit Sub
    End If
    
    Dim elsIsConsolidator As Boolean
    elsIsConsolidator = ELS_IsConsolidator(csIntCode)
    If elsIsConsolidator Then
        Exit Sub
    End If
    
    'Lookup MailpieceShape.
    elsmpshape = CS32.GetVar("xUSE_INP")
    Set XV1 = DbfLookup(CS32.ShipDir & "CS_CARR.FIL", CS32.GetVar("xCARRIER"), True, Array("USE_INP"), 1)
    If (XV1.RowCount > 0) Then
        elsmpshape = XV1("USE_INP")
    End If
    Set XV1 = Nothing
    
    elsmpshape = XmlReadXPath(elsSettingsXml, "/ELS/MailpieceShapes/MailpieceShape[@use_inp='" & elsmpshape & "']/text()")
    If KiEmpty(elsmpshape) Then
        elsmpshape = "PARCEL"
    End If
    
    elsCountry = Alltrim(CS32.GetVar("xCOUNTRY"))
    If Len(elsCountry) = 2 Then
        elsCtryIso = elsCountry
    Else
        If KiEmpty(elsCountry) Or elsCountry = "UNITED STATES" Or elsCountry = "US" Then
            elsCtryIso = "US"
        Else
            Set XV1 = DbfSelect(CS32.ShipDir & "POS\POS_IZON.FIL", "COUNTRY='" & PadR(elsCountry, 30) & "'", "ISO_CODE", 1)
            elsCtryIso = XV1("ISO_CODE")
        End If
    End If

    elsTransID = "Rate-" & Alltrim(CS32.GetVar("xPKGID")) & "-" & Alltrim(Str(Val(CS32.GetVar("xORD_CNT"))))

    elsCsAcct = Alltrim(CS32.GetVar("xACCOUNT"))

    XC10 = "" & _
        "<PostageRateRequest>" & vbLf & _
        vbTab & XmlWriteTag("RequestID", elsTransID) & vbLf & _
        vbTab & XmlWriteTag("RequesterID", "llse") & vbLf & _
        vbTab & "<CertifiedIntermediary>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("AccountID", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & elsCsAcct & "']/@AccountID")) & vbLf & _
        vbTab & vbTab & XmlWriteTag("PassPhrase", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & elsCsAcct & "']/@PassPhrase")) & vbLf & _
        vbTab & "</CertifiedIntermediary>" & vbLf & _
        vbTab & XmlWriteTag("MailClass", elsMailClass) & vbLf & _
        vbTab & XmlWriteTag("WeightOz", Str(Roundup(Val(CS32.GetVar("xACT_WGT")) * 16, 1))) & vbLf & _
        vbTab & XmlWriteTag("MailpieceShape", elsmpshape) & vbLf
        
    XN2 = Val(CS32.GetVar("xDIM_LENGTH"))
    XN3 = Val(CS32.GetVar("xDIM_WIDTH"))
    XN4 = Val(CS32.GetVar("xDIM_HEIGHT"))
    If (XN2 * XN3 * XN4) > 0 Then
        XC10 = XC10 & _
            vbTab & "<MailpieceDimensions>" & vbLf & _
            vbTab & vbTab & XmlWriteTag("Length", Alltrim(Str(XN2, 6, 2))) & vbLf & _
            vbTab & vbTab & XmlWriteTag("Width", Alltrim(Str(XN3, 6, 2))) & vbLf & _
            vbTab & vbTab & XmlWriteTag("Height", Alltrim(Str(XN4, 6, 2))) & vbLf & _
            vbTab & "</MailpieceDimensions>" & vbLf
    End If
    XC10 = XC10 & _
        vbTab & XmlWriteTag("AutomationRate", "FALSE") & vbLf & _
        vbTab & XmlWriteTag("Machinable", "TRUE") & vbLf & _
        vbTab & "<Services {SERVICELIST} />" & vbLf

    XC2 = " "
    If shipIso = "US" Then
        XC3 = CS32.GetVar("xUSE_DCR")
        If XC3 = "Y" Then
            XC2 = XC2 & "DeliveryConfirmation=""ON"" "
        ElseIf XC3 = "S" Then
            XC2 = XC2 & "SignatureConfirmation=""ON"" "
        End If
        
        If CS32.GetVar("xUSE_CERT") = "Y" Then
            XC2 = XC2 & "CertifiedMail=""ON"" "
        End If
    
        XN1 = Val(CS32.GetVar("xCOD_AMT"))
        If XN1 > 0 Then
            XC2 = XC2 & "COD=""ON"" "
            XC10 = XC10 & _
                vbTab & XmlWriteTag("CODAmount", Alltrim(Str(XN1, 8, 2))) & vbLf
            
            CS32.SetVar "xUSE_COD", "Y"
        End If
    Else
        CS32.SetVar "xUSE_DCR", "N"
        CS32.SetVar "xUSE_CERT", "N"
        CS32.SetVar "xUSE_COD", "N"
    End If

    If CS32.GetVar("xUSE_RTN") = "Y" Then
        XC2 = XC2 & "ReturnReceipt=""ON"" "
    End If
    
    'XC2 &= 'ElectronicReturnReceipt="OFF" '
    'XC2 &= 'RestrictedDelivery="OFF" '
    
    XC10 = XC10 & _
        vbTab & XmlWriteTag("Value", "0") & vbLf
    
    XN1 = Val(CS32.GetVar("xINS_AMT"))
    If XN1 > 0 Then
        XC2 = XC2 & "InsuredMail=""Endicia"" "
        XC10 = XC10 & vbTab & XmlWriteTag("InsuredValue", Alltrim(Str(XN1, 8, 2))) & vbLf
        CS32.SetVar "xUSE_INS", "Y"
    End If
    
    XN1 = Val(CS32.GetVar("xREG_AMT"))
    XC3 = CS32.GetVar("xUSE_REG")
    If XN1 > 0 Or XC3 = "Y" Then
        XC2 = XC2 & "RegisteredMail=""ON"" "
        XC10 = XC10 & _
            vbTab & XmlWriteTag("RegisteredMailValue", Alltrim(Str(XN1, 8, 2))) & vbLf
        
        CS32.SetVar "xUSE_REG", "Y"
    End If
    
    XC10 = StrTran(XC10, "{SERVICELIST}", Alltrim(XC2))
    
    XC10 = XC10 & vbTab & XmlWriteTag("EntryFacility", "Other") & vbLf
        
    If CS32.GetVar("xUSE_CVD") = "Y" Then
        XC2 = Alltrim(CS32.GetVar("xZIP"))
        XC3 = ""
        XC4 = CS32.GetVar("xCOUNTRY")
        If (KiEmpty(XC4) Or XC4 = "US" Or XC4 = "UNITED STATES") Then
            If InStr(XC2, "-") > 0 Then
                XC3 = SubToken(XC2, 2, "-")
            End If
            XC2 = Left(XC2, 5)
        End If
        
        XC10 = XC10 & vbTab & XmlWriteTag("FromPostalCode", XC2) & vbLf
    
        XC10 = XC10 & _
            vbTab & XmlWriteTag("ToPostalCode", Alltrim(CS32.GetVar("xFROMZIP"))) & vbLf & _
            vbTab & XmlWriteTag("ToZIP4", "") & vbLf & _
            vbTab & XmlWriteTag("ToCountryCode", "US") & vbLf
    Else
        XC10 = XC10 & vbTab & XmlWriteTag("FromPostalCode", Alltrim(CS32.GetVar("xFROMZIP"))) & vbLf
            
        XC2 = Alltrim(CS32.GetVar("xZIP"))
        XC3 = ""
        XC4 = CS32.GetVar("xCOUNTRY")
        If (KiEmpty(XC4) Or XC4 = "US" Or XC4 = "UNITED STATES") Then
            If InStr(XC2, "-") > 0 Then
                XC3 = SubToken(XC2, 2, "-")
            End If
            XC2 = Left(XC2, 5)
        End If
        
        XC10 = XC10 & _
            vbTab & XmlWriteTag("ToPostalCode", XC2) & vbLf & _
            vbTab & XmlWriteTag("ToZIP4", XC3) & vbLf & _
            vbTab & XmlWriteTag("ToCountryCode", elsCtryIso) & vbLf
    End If
    
    XC10 = XC10 & vbTab & "<ResponseOptions PostagePrice=""TRUE"" />" & vbLf & _
        "</PostageRateRequest>" & vbLf

    If elsXmlTrans <> XC10 Or (elsResponseXml Is Nothing) Then
        elsXmlTrans = XC10
            
        elsXmlResponseTxt = ELS_SendXml((elsXmlTrans), "postageRateRequestXML", (elsTransID), (elsCsAcct))
        
        Set elsResponseXml = New MSXML2.DOMDocument60
        elsResponseXml.loadXML elsXmlResponseTxt

        XN1 = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/Status"))
        If XN1 <> 0 Then
            XC2 = Alltrim(XmlReadXPath(elsResponseXml, "/PostageRateResponse/ErrorMessage"))
            CS32.SetVar "xERROR", "Endicia Label Server Error (" & Str(XN1) & "): " & XC2
            Exit Sub
        End If
    End If

    CS32.SetVar "xZONE", XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Postage/Zone/text()")
    
    Dim dblTotChg As Double, dblElsFee As Double, dblCsFee As Double
    
    dblTotChg = Val(CS32.GetVar("xTOT_CHG"))
    
    'Base postage
    dblCsFee = Val(CS32.GetVar("xSHP_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Postage/@TotalAmount"))
    CS32.SetVar "xSHP_CHG", Alltrim(Str(dblElsFee, 8, 2))
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
    
    XC2 = "CertificateOfMailing"
    dblCsFee = 0
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "CertifiedMail"
    dblCsFee = Val(CS32.GetVar("xCERT_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    CS32.SetVar "xCERT_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "CollectOnDelivery"
    dblCsFee = Val(CS32.GetVar("xCOD_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    CS32.SetVar "xCOD_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "DeliveryConfirmation"
    dblCsFee = Val(CS32.GetVar("xDCR_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    If dblElsFee = 0 Then
        XC2 = "SignatureConfirmation"
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    End If
    CS32.SetVar "xDCR_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "ElectronicReturnReceipt"
    dblCsFee = 0
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "InsuredMail"
    dblCsFee = Val(CS32.GetVar("xINS_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    CS32.SetVar "xINS_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "RegisteredMail"
    dblCsFee = Val(CS32.GetVar("xREG_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    CS32.SetVar "xREG_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "RestrictedDelivery"
    dblCsFee = 0
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "ReturnReceipt"
    dblCsFee = Val(CS32.GetVar("xRTN_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    CS32.SetVar "xRTN_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "ReturnReceiptForMerchandise"
    dblCsFee = 0
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    XC2 = "SpecialHandling"
    dblCsFee = Val(CS32.GetVar("xSHND_CHG"))
    dblElsFee = Val(XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Fees/" & XC2 & "/text()"))
    CS32.SetVar "xSHND_CHG", Str(dblElsFee, 8, 2)
    dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
    CS32.SetVar "xTOT_CHG", Str(dblTotChg, 8, 2)
End Sub

Sub ELS_RateDisplay()
    If Left(CS32.GetVar("xINTCODE"), 2) <> "ZE" Then
        Exit Sub
    End If
    
    CS32.RightMiddle ""
    
    XC1 = XmlReadXPath(elsResponseXml, "/PostageRateResponse/PostagePrice/Postage/MailService/text()")
    If Not KiEmpty(XC1) Then
        CS32.RightMiddle XC1
    End If
    
    CS32.RightMiddle PadR("Shipping", 19) + Str(Val(CS32.GetVar("xSHP_CHG")), 8, 2)
    
    XN1 = Val(CS32.GetVar("xCOD_CHG"))
    If XN1 > 0 Then
        CS32.RightMiddle PadR("COD", 19) + Str(XN1, 8, 2)
    End If
    
    XN1 = Val(CS32.GetVar("xINS_CHG"))
    If XN1 > 0 Then
        CS32.RightMiddle PadR("Insurance", 19) + Str(XN1, 8, 2)
    End If
    
    XN1 = Val(CS32.GetVar("xDCR_CHG"))
    If XN1 > 0 Then
        XC2 = CS32.GetVar("xUSE_DCR")
        If XC2 = "S" Then
            XC1 = "Signature Confirmation"
        Else
            XC1 = "Delivery Confirmation"
        End If
        CS32.RightMiddle PadR(XC1, 19) + Str(XN1, 8, 2)
    End If
    
    XN1 = Val(CS32.GetVar("xREG_CHG"))
    If XN1 > 0 Then
        CS32.RightMiddle PadR("Registered Mail", 19) + Str(XN1, 8, 2)
    End If
    
    XN1 = Val(CS32.GetVar("xCERT_CHG"))
    If XN1 > 0 Then
        CS32.RightMiddle PadR("Certified Mail", 19) + Str(XN1, 8, 2)
    End If
End Sub

Function ELS_SendXml(elsTransXml As String, elsXmlPrefix As String, elsTransID As String, elsAcctID As String) As String
    'PopStatus "Endicia Label Server", "Sending " & elsXmlPrefix
    
    elsTransID = Alltrim(elsTransID)
    elsTransID = StrTran(elsTransID, "\", "_")
    elsTransID = StrTran(elsTransID, "/", "_")
    elsTransID = StrTran(elsTransID, ":", "_")
    elsTransID = StrTran(elsTransID, "*", "_")
    elsTransID = StrTran(elsTransID, "?", "_")
    elsTransID = StrTran(elsTransID, "<", "_")
    elsTransID = StrTran(elsTransID, ">", "_")
    elsTransID = StrTran(elsTransID, "|", "_")
    
    'Save file
    XC1 = ""
    Do While fExist(elsDir & "XML\" & elsTransID & XC1 & ".xml")
        XC1 = Alltrim(Str(Val(XC1) - 1))
    Loop
    elsTransID = elsTransID & XC1
    
    elsFileNum0 = FreeFile
    kiDebug elsTransID & ".xml: " & elsFileNum0, ProjectDir & "Debug.log", "ELS_SendXML()"
    Open elsDir & "XML\" & elsTransID & ".xml" For Output As #elsFileNum0
    Print #elsFileNum0, elsTransXml
    Close #elsFileNum0
    
    XC1 = XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & elsAcctID & "']/@Test")
    elsServer = XmlReadXPath(elsSettingsXml, "/ELS/Servers/Server[@Test='" & XC1 & "']/Default/text()")
    If elsTransID = "RefundRequest" Then
        elsServer = XmlReadXPath(elsSettingsXml, "/ELS/Servers/Server[@Test='" & XC1 & "']/Refund/text()")
    End If
    
    elsUrl = XmlReadXPath(elsSettingsXml, "/ELS/URLs/URL[@Trans='" & elsXmlPrefix & "']/text()")
    
    'Send to Endicia
    If logLvl >= 2 Then
        logTxt = "ELS: Send to Endicia: " & elsTransID
        'LogWrite
    End If
    
    elsTransXml = StrTran(elsTransXml, vbTab, "")
    elsTransXml = StrTran(elsTransXml, vbLf, "")
    elsTransXml = URLEncode(elsTransXml)
    
    Set elsHttp = New MSXML2.ServerXMLHTTP60
    elsHttp.setOption 2, 13056
    elsHttp.setTimeouts 30000, 30000, 30000, 30000
    elsHttp.Open "POST", "https://" & elsServer & elsUrl, False
    elsHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
    elsHttp.send elsXmlPrefix & "=" & elsTransXml
    XC1 = elsHttp.responseText
    
    XN1 = InStr(XC1, "<?")
    If XN1 > 0 Then
        XC2 = SubStr(XC1, XN1)
        XN1 = InStr(XC2, ">")
        XC2 = Left(XC2, XN1 + 1)
        XC1 = StrTran(XC1, XC2, "")
    End If
    
    XN1 = InStr(XC1, "<")
    If XN1 > 0 Then
        XC1 = SubStr(XC1, XN1)
        XN1 = InStr(XC1, ">")
        XC2 = Left(XC1, XN1 + 1)
        XN1 = InStr(XC2, " ")
        If XN1 > 0 Then
            XC1 = StrTran(XC1, XC2, Left(XC2, XN1 - 1) & ">")
        End If
    End If
    
    ELS_SendXml = XC1
    
    If logLvl >= 2 Then
        logTxt = "ELS: Response received."
        'LogWrite
    End If
    'Debug(elsResponseXml)
    
    'Save response to file.
    elsFileNum0 = FreeFile
    kiDebug elsTransID & "-response.xml: " & elsFileNum0, ProjectDir & "Debug.log", "ELS_SendXML()"
    Open elsDir & "XML\" & elsTransID & ".xml" For Output As #elsFileNum0
    Print #elsFileNum0, ELS_SendXml
    Close #elsFileNum0
    
    KillStatus
End Function

Function XmlReadXPath(ByRef xmlDoc As MSXML2.DOMDocument60, strXPath As String) As String
    XmlReadXPath = ""
    If xmlDoc Is Nothing Then
        Exit Function
    End If
    
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    xmlDoc.setProperty "SelectionLanguage", "XPath"
    Set xmlNode = xmlDoc.selectSingleNode(strXPath)
    
    If Not (xmlNode Is Nothing) Then
        XmlReadXPath = xmlNode.Text
    End If
    Set xmlNode = Nothing
End Function
Function XmlReadXPathFromText(strXmlText As String, strXPath As String) As String
    Dim xmlDoc As MSXML2.DOMDocument60
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    Set xmlDoc = New MSXML2.DOMDocument60
    xmlDoc.loadXML strXmlText
    xmlDoc.setProperty "SelectionLanguage", "XPath"
    
    Set xmlNode = xmlDoc.selectSingleNode(strXPath)
    
    XmlReadXPathFromText = ""
    If Not (xmlNode Is Nothing) Then
        XmlReadXPathFromText = xmlNode.Text
    End If
    Set xmlNode = Nothing
End Function

Function XmlWriteTag(ByVal strTagName As String, ByVal strValue As String) As String
    XmlWriteTag = "<" & strTagName & ">" & XmlSafe(strValue) & "</" & strTagName & ">"
End Function

Function XmlSafe(strValue As String) As String
    XmlSafe = strValue
    
    XmlSafe = StrTran(XmlSafe, "&", "&amp;")
    XmlSafe = StrTran(XmlSafe, "<", "&lt;")
    XmlSafe = StrTran(XmlSafe, ">", "&gt;")
    XmlSafe = StrTran(XmlSafe, """", "&quot;")
End Function

Private Function DecodeBase64(ByVal strData As String) As String
 
    Dim objXML As MSXML2.DOMDocument60
    Dim objNode As MSXML2.IXMLDOMElement
    
    ' help from MSXML
    Set objXML = New MSXML2.DOMDocument60
    Set objNode = objXML.createElement("b64")
    objNode.DataType = "bin.base64"
    objNode.Text = strData
    DecodeBase64 = objNode.nodeTypedValue
    
    ' thanks, bye
    Set objNode = Nothing
    Set objXML = Nothing
 
End Function

Sub ELS_Cleanup()
    XN1 = 0
    XC1 = fFirst(elsDir & "XML\" & "*.*")
    Do While fExist(elsDir & "XML\" & XC1)
        If CtoD(fDate(elsDir & "XML\" & XC1)) < (Date - 7) Then
            If fErase(elsDir & "XML\" & XC1) Then
                XN1 = XN1 + 1
            End If
        End If
        XC1 = fNext()
    Loop

    XN1 = 0
    XC1 = fFirst(elsDir & "Labels\" & "*.*")
    Do While fExist(elsDir & "Labels\" & XC1)
        If CtoD(fDate(elsDir & "Labels\" & XC1)) < (Date - 7) Then
            If fErase(elsDir & "Labels\" & XC1) Then
                XN1 = XN1 + 1
            End If
        End If
        XC1 = fNext()
    Loop

    elsLastCleanup = Now
End Sub

Sub ELS_Utilities()
    Set XV1 = DbfLookup(CS32.ShipDir & "PROFILES\USER.FIL", PadR(CS32.GetVar("xUSERNAME"), 10, " "), True, "UTILITY")
    XC1 = SubStr(XV1("UTILITY"), 5, 1)
    Set XV1 = Nothing
    
    If XC1 = "1" Then
        formEndiciaAPIUtilities.Show vbModal
    Else
        MsgBox "Access denied." & vbLf & "You must have the 'Carrier Setup' right to access this utility.", vbCritical, "Endicia API Utilities"
    End If
End Sub

Function ELS_Purchase(intCsAcct As Integer, dblPostageAmt As Double) As Boolean
    elsTransID = "BuyPostage-" & Now

    elsXmlTrans = "<RecreditRequest>" & vbLf & _
        vbTab & XmlWriteTag("RequesterID", "llse") & vbLf & _
        vbTab & XmlWriteTag("RequestID", elsTransID) & vbLf & _
        vbTab & "<CertifiedIntermediary>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("AccountID", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']/@AccountID")) & vbLf & _
        vbTab & vbTab & XmlWriteTag("PassPhrase", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']/@PassPhrase")) & vbLf & _
        vbTab & "</CertifiedIntermediary>" & vbLf & _
        vbTab & XmlWriteTag("RecreditAmount", Alltrim(Str(dblPostageAmt, 8, 2))) & vbLf & _
        "</RecreditRequest>" & vbLf

    Dim elsResponseXml As MSXML2.DOMDocument60
    elsResponsetxt = ELS_SendXml((elsXmlTrans), "recreditRequestXML", (elsTransID), (intCsAcct))
        
    Set elsResponseXml = New MSXML2.DOMDocument60
    elsResponseXml.loadXML elsResponsetxt

    XN1 = Val(XmlReadXPath(elsResponseXml, "/RecreditRequestResponse/Status"))
    If XN1 <> 0 Then
        XC2 = Alltrim(XmlReadXPath(elsResponseXml, "/RecreditRequestResponse/ErrorMessage"))
        MsgBox XC2 & "(" & Alltrim(Str(XN1)), vbCritical, "Endicia Label Server: Recredit Request"
        ELS_Purchase = False
    Else
        ELS_Purchase = True
    End If
End Function

Function ELS_UpdatePassPhrase(intCsAcct As Integer, strPassCurrent As String, strPassNew As String) As Boolean
    elsTransID = "ChangePass-" & Now

    elsXmlTrans = "<ChangePassPhraseRequest>" & vbLf & _
        vbTab & XmlWriteTag("RequesterID", "llse") & vbLf & _
        vbTab & XmlWriteTag("RequestID", elsTransID) & vbLf & _
        vbTab & "<CertifiedIntermediary>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("AccountID", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']/@AccountID")) & vbLf & _
        vbTab & vbTab & XmlWriteTag("PassPhrase", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']/@PassPhrase")) & vbLf & _
        vbTab & "</CertifiedIntermediary>" & vbLf & _
        vbTab & XmlWriteTag("NewPassPhrase", strPassNew) & vbLf & _
        "</ChangePassPhraseRequest>" & vbLf

    Dim elsResponseXml As MSXML2.DOMDocument60
    elsResponsetxt = ELS_SendXml((elsXmlTrans), "changePassPhraseRequestXML", (elsTransID), (intCsAcct))
        
    Set elsResponseXml = New MSXML2.DOMDocument60
    elsResponseXml.loadXML elsResponsetxt

    XN1 = Val(XmlReadXPath(elsResponseXml, "/ChangePassPhraseRequestResponse/Status"))
    If XN1 <> 0 Then
        XC2 = Alltrim(XmlReadXPath(elsResponseXml, "/ChangePassPhraseRequestResponse/ErrorMessage"))
        MsgBox XC2 & "(" & Alltrim(Str(XN1)), vbCritical, "Endicia Label Server: Update Passphrase"
        ELS_UpdatePassPhrase = False
    Else
        Dim xmlAcctNode As MSXML2.IXMLDOMNode
        Set xmlAcctNode = elsSettingsXml.selectSingleNode("/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']")
        xmlAcctNode.Attributes.getNamedItem("PassPhrase").Text = strPassNew
        
        elsSettingsXml.save elsDir & "ElsConfig.xml"
        Set xmlAcctNode = Nothing
        
        ELS_UpdatePassPhrase = True
    End If
End Function

Sub ELS_Refund()
    elsMailClass = XmlReadXPath(elsSettingsXml, "/ELS/MailClasses/MailClass[@intcode='" & CS32.GetVar("xxINTCODE") & "']/text()")
    If KiEmpty(elsMailClass) Or CS32.GetVar("xxSTATUS") <> "VOID" Then
        Exit Sub
    End If

    Dim elsCsAcct As String
    Dim elsIDType As String
    Dim elsTest As String
    
    elsCsAcct = Alltrim(CS32.GetVar("xxACCOUNT"))
    elsTransID = "Refund-" + Alltrim(CS32.GetVar("xxTRACK_NO"))
    
    elsTest = Left(XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & elsCsAcct & "']/@Test"), 1)

    elsXmlTrans = "<?xml version=""1.0"" encoding=""utf-8""?>" & vbLf & _
        "<RefundRequest>" & vbLf & _
        vbTab & XmlWriteTag("RequesterID", "llse") & vbLf & _
        vbTab & XmlWriteTag("RequestID", elsTransID) & vbLf & _
        vbTab & "<CertifiedIntermediary>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("AccountID", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(elsCsAcct)) & "']/@AccountID")) & vbLf & _
        vbTab & vbTab & XmlWriteTag("PassPhrase", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(elsCsAcct)) & "']/@PassPhrase")) & vbLf & _
        vbTab & "</CertifiedIntermediary>" & vbLf & _
        vbTab & "<PicNumbers>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("PicNumber", Alltrim(CS32.GetVar("xxTRACK_NO"))) & vbLf & _
        vbTab & "</PicNumbers>" & vbLf & _
        "</RefundRequest>"

    Dim elsResponseXml As MSXML2.DOMDocument60
    elsResponsetxt = ELS_SendXml((elsXmlTrans), "refundRequestXML", (elsTransID), (elsCsAcct))
        
    Set elsResponseXml = New MSXML2.DOMDocument60
    elsResponseXml.loadXML elsResponsetxt

    XN1 = Val(XmlReadXPath(elsResponseXml, "/RefundResponse/Status"))
    If XN1 <> 0 Then
        XC2 = Alltrim(XmlReadXPath(elsResponseXml, "/RefundResponse/ErrorMessage"))
        MsgBox XC2 & "(" & Alltrim(Str(XN1)), vbCritical + vbApplicationModal, "Endicia Label Server: Refund Request"
    Else
        MsgBox "Postage refunded to account", vbInformation + vbApplicationModal, "Endicia Label Server: Refund Request"
    End If
End Sub

Sub ELS_GetManifest_Trigger()
    If fExist("C:\Temp\dhlmanifest.go") Then
        fErase "C:\Temp\dhlmanifest.go"
                
        elsTransID = "GetDHLGMManifest-" & Now

        elsXmlTrans = "<CreateDHLGMManifestRequest>" & vbLf & _
            vbTab & XmlWriteTag("RequesterID", "llse") & vbLf & _
            vbTab & XmlWriteTag("RequestID", elsTransID) & vbLf & _
            vbTab & "<CertifiedIntermediary>" & vbLf & _
            vbTab & vbTab & XmlWriteTag("AccountID", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']/@AccountID")) & vbLf & _
            vbTab & vbTab & XmlWriteTag("PassPhrase", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(Str(intCsAcct)) & "']/@PassPhrase")) & vbLf & _
            vbTab & "</CertifiedIntermediary>" & vbLf & _
            vbTab & XmlWriteTag("RecreditAmount", Alltrim(Str(dblPostageAmt, 8, 2))) & vbLf & _
            "</CreateDHLGMManifestRequest>" & vbLf
    
        Dim elsResponseXml As MSXML2.DOMDocument60
        elsResponsetxt = ELS_SendXml((elsXmlTrans), "CreateDHLGMManifestXML", (elsTransID), (1))
            
        Set elsResponseXml = New MSXML2.DOMDocument60
        elsResponseXml.loadXML elsResponsetxt
    
        XN1 = Val(XmlReadXPath(elsResponseXml, "/CreateDHLGMManifestResponse/Status"))
        If XN1 <> 0 Then
            XC2 = Alltrim(XmlReadXPath(elsResponseXml, "/CreateDHLGMManifestResponse/ErrorMessage"))
            MsgBox XC2 & "(" & Alltrim(Str(XN1)), vbCritical, "Endicia Label Server: CreateDHLGMManifest Request"
        End If
    End If
End Sub

Function ELS_GetMailClass(ByVal strIntCode As String) As String
    ELS_GetMailClass = XmlReadXPath(elsSettingsXml, "/ELS/MailClasses/MailClass[@intcode='" & strIntCode & "']/text()")
End Function

Function ELS_IsConsolidator(strIntCode As String) As String
    ELS_IsConsolidator = (Upper(XmlReadXPath(elsSettingsXml, "ELS/MailClasses/MailClass[@intcode='" & strIntCode & "']/@consolidator")) = "Y")
End Function

Function ELS_BuildCustomsInfo(ByVal elsCsAcct As String, ByVal elsCsIntCode As String) As String
    formEndiciaAPICustoms.Show
    
    Dim elsSenderRefField As String
    Dim elsImporter As String
    
    Dim elsContentsType As String
    
    elsSenderRefField = XmlReadXPath(elsSettingsXml, "/ELS/Settings[@Account='" & elsCsAcct & "']/SenderCustomsReference/text()")
    If KiEmpty(elsSenderRefField) Then
        elsSenderRefField = XmlReadXPath(elsSettingsXml, "/ELS/Settings[not(@Account)]/SenderCustomsReference/text()")
    End If
    If KiEmpty(elsSenderRefField) Then
        elsSenderRefField = "REF"
    End If
    
    elsImporterRefField = XmlReadXPath(elsSettingsXml, "/ELS/Settings[@Account='" & elsCsAcct & "']/ImporterCustomsReference/text()")
    If KiEmpty(elsImporterRefField) Then
        elsImporterRefField = XmlReadXPath(elsSettingsXml, "/ELS/Settings[not(@Account)]/ImporterCustomsReference/text()")
    End If
    If KiEmpty(elsImporterRefField) Then
        elsImporterRefField = "PO_NO"
    End If
    
    elsContentsType = ""
    If elsCustomsDoc Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "Documents"
    End If
    If elsCustomsGift Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "Gift"
    End If
    If elsCustomsMerch Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "Merchandise"
    End If
    If elsCustomsReturn Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "ReturnedGoods"
    End If
    If elsCustomsSample Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "Sample"
    End If
    If elsCustomsDonate Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "HumanitarianDonation"
    End If
    If elsCustomsDG Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "DangerousGoods"
    End If
    If elsCustomsOther Then
        If Not KiEmpty(elsContentsType) Then
            elsContentsType = elsContentsType & ", "
        End If
        elsContentsType = elsContentsType & "Other"
    End If
    
    ELS_BuildCustomsInfo = "<CustomsInfo>" & vbLf & _
        vbTab & XmlWriteTag("ContentsType", elsContentsType) & vbLf & _
        vbTab & XmlWriteTag("ContentsExplanation", elsCustomsOtherDesc) & vbLf & _
        vbTab & XmlWriteTag("RestrictionType", "None") & vbLf & _
        vbTab & XmlWriteTag("RestrictionComments", "") & vbLf & _
        vbTab & XmlWriteTag("SendersCustomsReference", Alltrim(CS32.GetVar("x" & elsSenderRefField))) & vbLf & _
        vbTab & XmlWriteTag("ImportersCustomsReference", Alltrim(CS32.GetVar("x" & elsImporterRefField))) & vbLf & _
        vbTab & XmlWriteTag("LicenseNumber", "") & vbLf & _
        vbTab & XmlWriteTag("CertificateNumber", "") & vbLf & _
        vbTab & XmlWriteTag("InvoiceNumber", "") & vbLf & _
        vbTab & XmlWriteTag("NonDeliveryOption", "Return") & vbLf & _
        vbTab & XmlWriteTag("InsuredNumber", "") & vbLf & _
        vbTab & XmlWriteTag("EelPfc", "") & vbLf

    
    ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & vbTab & "<CustomsItems>" & vbLf
   
    If (elsCustomsQty1 > 0) Then
        XN1 = elsCustomsWgt1
        If elsCustomsWgtUnits = "LB" Then
            XN1 = XN1 * 16
        End If
        
        XC1 = vbTab & vbTab & "<CustomsItem>" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Description", elsCustomsDesc1) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Quantity", elsCustomsQty1) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Weight", Roundup(IIf(elsCustomsWgtPer = "LINE", XN1, XN1 * elsCustomsQty1), 1)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Value", IIf(elsCustomsWgtPer = "LINE", elsCustomsVal1, elsCustomsVal1 * elsCustomsQty1)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("HSTariffNumber", elsCustomsHts1) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("CountryOfOrigin", elsCustomsOrig1) & vbLf & _
            vbTab & vbTab & "</CustomsItem>" & vbLf
        
        ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & XC1
    End If
    If (elsCustomsQty2 > 0) Then
        XN1 = elsCustomsWgt2
        If elsCustomsWgtUnits = "LB" Then
            XN1 = XN1 * 16
        End If
        
        XC1 = vbTab & vbTab & "<CustomsItem>" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Description", elsCustomsDesc2) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Quantity", elsCustomsQty2) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Weight", Roundup(IIf(elsCustomsWgtPer = "LINE", XN1, XN1 * elsCustomsQty2), 1)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Value", IIf(elsCustomsWgtPer = "LINE", elsCustomsVal2, elsCustomsVal2 * elsCustomsQty2)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("HSTariffNumber", elsCustomsHts2) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("CountryOfOrigin", elsCustomsOrig2) & vbLf & _
            vbTab & vbTab & "</CustomsItem>" & vbLf
        
        ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & XC1
    End If
    If (elsCustomsQty3 > 0) Then
        XN1 = elsCustomsWgt3
        If elsCustomsWgtUnits = "LB" Then
            XN1 = XN1 * 16
        End If
        
        XC1 = vbTab & vbTab & "<CustomsItem>" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Description", elsCustomsDesc3) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Quantity", elsCustomsQty3) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Weight", Roundup(IIf(elsCustomsWgtPer = "LINE", XN1, XN1 * elsCustomsQty3), 1)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Value", IIf(elsCustomsWgtPer = "LINE", elsCustomsVal3, elsCustomsVal3 * elsCustomsQty3)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("HSTariffNumber", elsCustomsHts3) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("CountryOfOrigin", elsCustomsOrig3) & vbLf & _
            vbTab & vbTab & "</CustomsItem>" & vbLf
        
        ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & XC1
    End If
    If (elsCustomsQty4 > 0) Then
        XN1 = elsCustomsWgt4
        If elsCustomsWgtUnits = "LB" Then
            XN1 = XN1 * 16
        End If
        
        XC1 = vbTab & vbTab & "<CustomsItem>" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Description", elsCustomsDesc4) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Quantity", elsCustomsQty4) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Weight", Roundup(IIf(elsCustomsWgtPer = "LINE", XN1, XN1 * elsCustomsQty4), 1)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Value", IIf(elsCustomsWgtPer = "LINE", elsCustomsVal4, elsCustomsVal4 * elsCustomsQty4)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("HSTariffNumber", elsCustomsHts4) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("CountryOfOrigin", elsCustomsOrig4) & vbLf & _
            vbTab & vbTab & "</CustomsItem>" & vbLf
        
        ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & XC1
    End If
    If (elsCustomsQty5 > 0) Then
        XN1 = elsCustomsWgt5
        If elsCustomsWgtUnits = "LB" Then
            XN1 = XN1 * 16
        End If
        
        XC1 = vbTab & vbTab & "<CustomsItem>" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Description", elsCustomsDesc5) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Quantity", elsCustomsQty5) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Weight", Roundup(IIf(elsCustomsWgtPer = "LINE", XN1, XN1 * elsCustomsQty5), 1)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Value", IIf(elsCustomsWgtPer = "LINE", elsCustomsVal5, elsCustomsVal5 * elsCustomsQty5)) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("HSTariffNumber", elsCustomsHts5) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("CountryOfOrigin", elsCustomsOrig5) & vbLf & _
            vbTab & vbTab & "</CustomsItem>" & vbLf
        
        ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & XC1
    End If
    
    
    ELS_BuildCustomsInfo = ELS_BuildCustomsInfo & _
        vbTab & "</CustomsItems>" & vbLf & _
        "</CustomsInfo>" & vbLf & _
        XmlWriteTag("CustomsCertify", elsCustomsCertify) & vbLf & _
        XmlWriteTag("CustomsSigner", elsCustomsCertName) & vbLf
End Function


Public Sub ELS_OnClearTrans()
    elsCustomsQty1 = Null
    elsCustomsQty2 = Null
    elsCustomsQty3 = Null
    elsCustomsQty4 = Null
    elsCustomsQty5 = Null
    
    elsCustomsDesc1 = Null
    elsCustomsDesc2 = Null
    elsCustomsDesc3 = Null
    elsCustomsDesc4 = Null
    elsCustomsDesc5 = Null
    
    elsCustomsWgt1 = Null
    elsCustomsWgt2 = Null
    elsCustomsWgt3 = Null
    elsCustomsWgt4 = Null
    elsCustomsWgt5 = Null
    
    elsCustomsVal1 = Null
    elsCustomsVal2 = Null
    elsCustomsVal3 = Null
    elsCustomsVal4 = Null
    elsCustomsVal5 = Null
    
    elsCustomsHts1 = Null
    elsCustomsHts2 = Null
    elsCustomsHts3 = Null
    elsCustomsHts4 = Null
    elsCustomsHts5 = Null
    
    elsCustomsOrig1 = Null
    elsCustomsOrig2 = Null
    elsCustomsOrig3 = Null
    elsCustomsOrig4 = Null
    elsCustomsOrig5 = Null
    
    elsCustomsSample = Null
    elsCustomsDG = Null
    elsCustomsDoc = Null
    elsCustomsMerch = Null
    elsCustomsDonate = Null
    elsCustomsReturn = Null
    elsCustomsGift = Null
    elsCustomsOther = Null
    elsCustomsOtherDesc = Null
    
    elsCustomsCertify = Null
    elsCustomsCertName = Null
End Sub

Public Function URLEncode(StringVal As String, Optional SpaceAsPlus As Boolean = False) As String
    URLEncode = StringVal
    
    Dim result() As String
    Dim StringLen As Long: StringLen = Len(StringVal)
    
    If StringLen > 0 Then
        ReDim result(StringLen) As String
        Dim i As Long, CharCode As Integer
        Dim Char As String, Space As String
        
        If SpaceAsPlus Then Space = "+" Else Space = "%20"
        For i = 1 To StringLen
            Char = Mid$(StringVal, i, 1)
            CharCode = Asc(Char)
            Select Case CharCode
                Case 97 To 122, 65 To 90, 48 To 57, 45, 46, 95, 126
                    result(i) = Char
                Case 32
                    result(i) = Space
                Case 0 To 15
                    result(i) = "%0" & Hex(CharCode)
                Case Else
                    result(i) = "%" & Hex(CharCode)
            End Select
        Next i
        URLEncode = Join(result, "")
    End If
End Function



Function ELS_Record()
    Dim csIntCode As String
    Dim elsMailClass As String
    
    csIntCode = CS32.GetVar("xINTCODE")
    
    elsMailClass = ELS_GetMailClass(csIntCode)
    If KiEmpty(elsMailClass) Then
        Exit Function
    End If
    
    CS32.SetVar "xCT_FLAG", CS32.GetVar("xUSE_CT")
    
    Dim sMailpieceShape As String
    Dim sLblType As String, sLblSubtype As String, sLblSubtypeForm As String
    
    Dim elsCompany, elsName, elsAddr1, elsAddr2, elsAddr3, elsCity, elsState, elsCountry, elsCtryIso As String
    Dim elsIsConsolidator As Boolean
    Dim elsXmlTrans As String
    
    elsIsConsolidator = ELS_IsConsolidator(csIntCode)
    
    elsCsAcct = Alltrim(CS32.GetVar("xACCOUNT"))
    
    'Make sure directory structure exists.
    'Turn off CS label printing.
    CS32.SetVar "xUSE_LABEL", "000000000"
    
    elsCompany = ""
    elsName = ""
    elsAddr1 = ""
    elsAddr2 = ""
    elsAddr3 = ""
    elsCity = ""
    elsState = ""
    
    If Upper(XmlReadXPath(elsSettingsXml, "/ELS/Settings/Addressing/text()")) = "LEGACY" Then
    'Clippership legacy addressing (shipto1-7).
        'Get city from last populated field.
        XN1 = 1
        XN2 = 7
        Do While XN2 >= 1
            elsCity = Alltrim(CS32.GetVar("xSHIPTO" & Alltrim(Str(XN2))))
            XN2 = XN2 - 1
            If Not KiEmpty(elsCity) Then
                Exit Do
            End If
        Loop
        
        'Populate addr1-6, starting from top.
        Do While XN1 <= XN2
            XC1 = Alltrim(Validated(Upper(CS32.GetVar("xSHIPTO" + Str(XN1))), 32, 32, 47, 58, 65, 90))
            If KiEmpty(elsAddr1) Then
                elsAddr1 = XC1
            ElseIf KiEmpty(elsAddr2) Then
                elsAddr2 = XC1
            ElseIf KiEmpty(elsAddr3) Then
                elsAddr3 = XC1
            ElseIf KiEmpty(elsAddr4) Then
                elsAddr4 = XC1
            ElseIf KiEmpty(elsAddr5) Then
                elsAddr5 = XC1
            ElseIf KiEmpty(elsAddr6) Then
                elsAddr6 = XC1
            End If
            XN1 = XN1 + 1
        Loop
    Else
    'Clippership standard addressing (shipto company, company2, name, addr1, addr1, addr3, city/state).
        elsCompany = Alltrim(Alltrim(CS32.GetVar("xSHIPTO1")) & " " & Alltrim(CS32.GetVar("xSHIPTO2")))
        elsName = Alltrim(CS32.GetVar("xSHIPTO3"))
        elsAddr1 = Alltrim(CS32.GetVar("xSHIPTO4"))
        elsAddr2 = Alltrim(CS32.GetVar("xSHIPTO5"))
        elsAddr3 = Alltrim(CS32.GetVar("xSHIPTO6"))
        elsCity = Alltrim(CS32.GetVar("xSHIPTO7"))
    End If
    
    elsCountry = Alltrim(CS32.GetVar("xCOUNTRY"))
    If Len(elsCountry) = 2 Then
        elsCtryIso = elsCountry
    Else
        If KiEmpty(elsCountry) Or elsCountry = "UNITED STATES" Or elsCountry = "US" Then
            elsCtryIso = "US"
        Else
            Set XV1 = DbfSelect(CS32.ShipDir & "POS\POS_IZON.FIL", "COUNTRY='" & PadR(elsCountry, 30) & "'", "ISO_CODE", 1)
            elsCtryIso = XV1("ISO_CODE")
        End If
    End If
    
    If (At("international", Lower(elsMailClass)) = 0 Or elsCountry = "CANADA") And Len(elsCity) > 3 Then
        'If is US or Canada, separate city/state(province).
        If SubStr(elsCity, Len(elsCity) - 2, 1) = " " Then
            elsState = Right(elsCity, 2)
            elsCity = Left(elsCity, Len(elsCity) - 2)
        End If
    End If
    
    'Lookup packaging type.
    sMailpieceShape = CS32.GetVar("xUSE_INP")
    Set XV1 = DbfLookup(CS32.ShipDir & "CS_CARR.FIL", CS32.GetVar("xCARRIER"), True, Array("USE_INP"), 1)
    If (XV1.RowCount > 0) Then
        sMailpieceShape = XV1("USE_INP")
    End If
    Set XV1 = Nothing
    CS32.SetVar "xINP_FLAG", sMailpieceShape
    
    sMailpieceShape = XmlReadXPath(elsSettingsXml, "/ELS/MailpieceShapes/MailpieceShape[@use_inp='" + sMailpieceShape + "']/text()")
    If KiEmpty(sMailpieceShape) Then
        sMailpieceShape = "Parcel"
    End If
    
    elsTransID = "Print-" + Alltrim(CS32.GetVar("xPKGID")) + "-" + Alltrim(CS32.GetVar("xORD_CNT"))
    
    elsLblFormatXmlStr = ELS_GetLabelFormat(elsMailClass, sMailpieceShape)
    
    sLblType = ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Type")
    sLblSubtype = ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Subtype")
    sLblSubtypeForm = ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "SubtypeForm")
    
    XC7 = CS32.GetVar("xWorkstation")
    XC8 = SubToken(IniRead(CS32.ShipDir & "PROFILES\" & XC7 & ".ini", "PeripheralSetup", "Label1", ""), 1, ",")
    
    elsXmlTrans = "" & _
        "<LabelRequest Test=""" & XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & elsCsAcct & "']/@Test") & """ " & _
            "LabelType=""" & sLblType & """ " & _
            "LabelSubtype=""" & sLblSubtype & """ " & _
            "LabelSize=""" & ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Size", sLblType) & """ " & _
            "ImageFormat=""" & ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Format", sLblType) & """ " & _
            "ImageResolution=""" & ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Resolution", sLblType) & """ " & _
            "ImageRotation=""" & ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Rotation", sLblType) & """ >" & vbLf & _
        vbTab & XmlWriteTag("RequestID", elsTransID) & vbLf & _
        vbTab & XmlWriteTag("RequesterID", "llse") & vbLf & _
        vbTab & XmlWriteTag("AccountID", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(CS32.GetVar("xACCOUNT")) & "']/@AccountID")) & vbLf & _
        vbTab & XmlWriteTag("PassPhrase", XmlReadXPath(elsSettingsXml, "/ELS/Accounts/Account[@ID='" & Alltrim(CS32.GetVar("xACCOUNT")) & "']/@PassPhrase")) & vbLf & _
        vbTab & XmlWriteTag("MailClass", elsMailClass) & vbLf & _
        vbTab & XmlWriteTag("DateAdvance", Str(CtoD(CS32.GetVar("xDATE")) - Date)) & vbLf & vbTab & _
        XmlWriteTag("WeightOz", Str(Roundup(Val(CS32.GetVar("xACT_WGT")) * 16, 0.1))) & vbLf & vbTab & _
        XmlWriteTag("MailpieceShape", sMailpieceShape) & vbLf
    
    XN2 = Val(CS32.GetVar("xDIM_LENGTH"))
    XN3 = Val(CS32.GetVar("xDIM_WIDTH"))
    XN4 = Val(CS32.GetVar("xDIM_HEIGHT"))
    If (XN2 * XN3 * XN4) > 0 Then
        elsXmlTrans = elsXmlTrans & _
            vbTab & "<MailpieceDimensions>" & vbLf & _
            vbTab & vbTab & XmlWriteTag("Length", Alltrim(Str(XN2, 6, 2))) & vbLf & _
            vbTab & vbTab & XmlWriteTag("Width", Alltrim(Str(XN3, 6, 2))) & vbLf & _
            vbTab & vbTab & XmlWriteTag("Height", Alltrim(Str(XN4, 6, 2))) & vbLf & _
            vbTab & "</MailpieceDimensions>" & vbLf
    End If
    
    elsXmlTrans = elsXmlTrans & _
        vbTab & XmlWriteTag("AutomationRate", "FALSE") & vbLf & _
        vbTab & XmlWriteTag("Machinable", "TRUE") & vbLf & _
        vbTab & XmlWriteTag("ShowReturnAddress", "TRUE") & vbLf & _
        vbTab & XmlWriteTag("Stealth", "TRUE") & vbLf & _
        vbTab & XmlWriteTag("ValidateAddress", "TRUE") & vbLf & _
        vbTab & XmlWriteTag("SignatureWaiver", "TRUE") & vbLf & _
        vbTab & XmlWriteTag("NoWeekendDelivery", "FALSE") & vbLf & _
        vbTab & "<Services {SERVICELIST} />" & vbLf & _
        vbTab & XmlWriteTag("Value", "0") & vbLf
    
    If elsIsConsolidator Then
        elsXmlTrans = elsXmlTrans & _
            vbTab & XmlWriteTag("IsConsolidator", "TRUE") & vbLf & _
            vbTab & XmlWriteTag("PrintConsolidatorLabel", "TRUE") & vbLf & _
            vbTab & XmlWriteTag("IncludePostage", "FALSE") & vbLf
    Else
        elsXmlTrans = elsXmlTrans & _
            vbTab & XmlWriteTag("IncludePostage", "TRUE") & vbLf
    End If
    
    If CS32.GetVar("xUSE_CVD") = "Y" Then
        XC3 = XmlReadXPath(elsSettingsXml, "/ELS/Settings[@Account='" & elsCsAcct & "']/PayOnUseReturns/text()")
        If KiEmpty(XC3) Then
            XC3 = Upper(XmlReadXPath(elsSettingsXml, "/ELS/Settings[not(@Account)]/PayOnUseReturns/text()"))
        End If
        
        If XC3 = "Y" Or XC3 = "TRUE" Or XC3 = "YES" Then
            elsXmlTrans = elsXmlTrans & XmlWriteTag("PrintScanBasedPaymentLabel", "TRUE") & vbLf
            CS32.SetVar "xCT_FLAG", "Q"
        Else
            elsXmlTrans = elsXmlTrans & XmlWriteTag("ReplyPostage", "TRUE") & vbLf
            CS32.SetVar "xCT_FLAG", "P"
        End If
    End If
    
    XC2 = " "
    
    XC3 = CS32.GetVar("xUSE_DCR")
    If XC3 = "Y" Then
        XC2 = XC2 & "DeliveryConfirmation=""ON"" "
    ElseIf XC3 = "S" Then
        XC2 = XC2 & "SignatureConfirmation=""ON"" "
    End If
    CS32.SetVar "xDCR_FLAG", XC3
    
    If CS32.GetVar("xUSE_CERT") = "Y" Then
        XC2 = XC2 & "CertifiedMail=""ON"" "
    End If
    
    If CS32.GetVar("xUSE_RTN") = "Y" Then
        XC2 = XC2 & "ReturnReceipt=""ON"" "
    End If
    
    XN1 = Val(CS32.GetVar("xCOD_AMT"))
    If XN1 > 0 Then
        XC2 = XC2 & "COD=""ON"" "
        elsXmlTrans = elsXmlTrans & vbTab & XmlWriteTag("CODAmount", Alltrim(Str(XN1, 8, 2))) & vbLf
        CS32.SetVar "xUSE_COD", "Y"
    End If
    
    XN1 = Val(CS32.GetVar("xINS_AMT"))
    If XN1 > 0 Then
        XC2 = XC2 & "InsuredMail=""Endicia"" "
        elsXmlTrans = elsXmlTrans & vbTab & XmlWriteTag("InsuredValue", Alltrim(Str(XN1, 8, 2))) & vbLf
        CS32.SetVar "xUSE_INS", "Y"
    End If
    
    XN3 = Val(CS32.GetVar("xREG_AMT"))
    XC3 = CS32.GetVar("xUSE_REG")
    If XN3 > 0 Or XC3 = "Y" Then
        XC2 = XC2 & "RegisteredMail=""ON"" "
        elsXmlTrans = elsXmlTrans & vbTab & XmlWriteTag("RegisteredMailValue", Alltrim(Str(XN1, 8, 2))) & vbLf
        CS32.SetVar "xUSE_REG", "Y"
    End If
    
    elsXmlTrans = StrTran(elsXmlTrans, "{SERVICELIST}", Alltrim(XC2))
    
    If Not KiEmpty(sLblSubtypeForm) Then
        elsXmlTrans = elsXmlTrans & vbTab & XmlWriteTag("IntegratedFormType", sLblSubtypeForm) & vbLf
    End If
    
    elsXmlTrans = elsXmlTrans & _
        vbTab & XmlWriteTag("CostCenterAlphaNumeric", Alltrim(CS32.GetVar("xDEPT"))) & vbLf & _
        vbTab & XmlWriteTag("ReferenceID", Alltrim(CS32.GetVar("xPKGID"))) & vbLf & _
        vbTab & XmlWriteTag("PartnerCustomerID", "ZING") & vbLf & _
        vbTab & XmlWriteTag("PartnerTransactionID", "ZING" & Alltrim(CS32.GetVar("xPKGID"))) & vbLf & _
        vbTab & XmlWriteTag("RubberStamp1", Alltrim(CS32.GetVar("xREMARK"))) & vbLf & _
        vbTab & XmlWriteTag("RubberStamp2", "") & vbLf & _
        vbTab & XmlWriteTag("RubberStamp3", "") & vbLf & _
        vbTab & XmlWriteTag("EntryFacility", "Other") & vbLf & _
        vbTab & XmlWriteTag("POZipCode", "") & vbLf & _
        vbTab & "<ResponseOptions PostagePrice=""TRUE"" />" & vbLf
        
        elsXmlTrans = elsXmlTrans & _
            vbTab & XmlWriteTag("FromCompany", Alltrim(CS32.GetVar("xFROM1"))) & vbLf & _
            vbTab & XmlWriteTag("ReturnAddress1", Alltrim(CS32.GetVar("xFROM2"))) & vbLf & _
            vbTab & XmlWriteTag("FromCity", Alltrim(CS32.GetVar("xFROMCITY"))) & vbLf & _
            vbTab & XmlWriteTag("FromState", Alltrim(CS32.GetVar("xFROMSTATE"))) & vbLf & _
            vbTab & XmlWriteTag("FromPostalCode", Alltrim(CS32.GetVar("xFROMZIP"))) & vbLf & _
            vbTab & XmlWriteTag("FromZIP4", "") & vbLf & _
            vbTab & XmlWriteTag("FromCountry", "UNITED STATES") & vbLf & _
            vbTab & XmlWriteTag("FromPhone", Validated(CS32.GetVar("xFROM4"), 48, 57, 0, 0, 0, 0)) & vbLf & _
            vbTab & XmlWriteTag("FromEMail", "") & vbLf & _
            vbTab & XmlWriteTag("ToName", elsName) & vbLf & _
            vbTab & XmlWriteTag("ToCompany", elsCompany) & vbLf & _
            vbTab & XmlWriteTag("ToAddress1", elsAddr1) & vbLf & _
            vbTab & XmlWriteTag("ToAddress2", elsAddr2) & vbLf & _
            vbTab & XmlWriteTag("ToAddress3", elsAddr3) & vbLf

        elsXmlTrans = elsXmlTrans & _
            vbTab & XmlWriteTag("ToCity", elsCity) & vbLf & _
            vbTab & XmlWriteTag("ToState", elsState) & vbLf
        
        XC2 = Alltrim(CS32.GetVar("xZIP"))
        XC3 = ""
        If elsCtryIso = "US" Then
            If InStr(XC2, "-") > 0 Then
                XC3 = SubToken(XC2, 2, "-")
            End If
            XC2 = Left(XC2, 5)
        End If
        
        elsXmlTrans = elsXmlTrans & _
            vbTab & XmlWriteTag("ToPostalCode", XC2) & vbLf & _
            vbTab & XmlWriteTag("ToZIP4", XC3) & vbLf & _
            vbTab & XmlWriteTag("ToDeliveryPoint", "") & vbLf & _
            vbTab & XmlWriteTag("ToCountryCode", elsCtryIso) & vbLf & _
            vbTab & XmlWriteTag("ToPhone", Alltrim(CS32.GetVar("xPHONE"))) & vbLf & _
            vbTab & XmlWriteTag("ToEMail", Alltrim(CS32.GetVar("xCONSEMAIL"))) & vbLf

    If sLblSubtypeForm = "Form2976" Or sLblSubtypeForm = "Form2976A" Then
        XC1 = ELS_BuildCustomsInfo(elsCsAcct, csIntCode)
        elsXmlTrans = elsXmlTrans & XC1
    End If
    
    elsXmlTrans = elsXmlTrans & "</LabelRequest>" & vbLf
    
    Dim elsResponseXml As MSXML2.DOMDocument60
    elsResponsetxt = ELS_SendXml((elsXmlTrans), "labelRequestXML", (elsTransID), (elsCsAcct))
    
    Set elsResponseXml = New MSXML2.DOMDocument60
    elsResponseXml.loadXML elsResponsetxt
    
    XC4 = XmlReadXPath(elsResponseXml, "LabelRequestResponse/Status")
    If KiEmpty(XC4) Then
        CS32.SetVar "xERROR", "Invalid response from Endicia: " & vbCrLf & elsResponsetxt
        Exit Function
    Else
        XN1 = Val(XC4)
        If XN1 <> 0 Then
            XC2 = Alltrim(XmlReadXPath(elsResponseXml, "LabelRequestResponse/ErrorMessage"))
            CS32.SetVar "xERROR", "Endicia Label Server Error (" & Alltrim(Str(XN1)) & "): " & XC2
            Exit Function
        End If
    End If
    
    PopStatus "Endicia Label Server", "Checking response..."
    
    XC4 = XmlReadXPath(elsResponseXml, "/LabelRequestResponse/TrackingNumber/text()")
    CS32.SetVar "xTRACK_NO", XC4
    CS32.SetVar "xTRACK_MOM", XC4
    
    If XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PIC/text()") = XC4 Then
        CS32.SetVar "xVDC_FLAG", "D"
    ElseIf XmlReadXPath(elsResponseXml, "/LabelRequestResponse/CustomsNumber/text()") = XC4 Then
        CS32.SetVar "xVDC_FLAG", "I"
    End If
    
    If Not elsIsConsolidator Then
    'Read in postage rates for non-consolidators (i.e. DHL GlobalMail).
    
        CS32.SetVar "xZONE", XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Postage/Zone/text()")
        
        Dim dblTotChg As Double, dblElsFee As Double, dblCsFee As Double
    
        dblTotChg = Val(CS32.GetVar("xTOT_CHG"))
        
        'Base postage
        dblCsFee = Val(CS32.GetVar("xSHP_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Postage/@TotalAmount"))
        CS32.SetVar "xSHP_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
        
        XC2 = "CertificateOfMailing"
        dblCsFee = 0
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "CertifiedMail"
        dblCsFee = Val(CS32.GetVar("xCERT_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        CS32.SetVar "xCERT_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "CollectOnDelivery"
        dblCsFee = Val(CS32.GetVar("xCOD_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        CS32.SetVar "xCOD_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "DeliveryConfirmation"
        dblCsFee = Val(CS32.GetVar("xDCR_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        If dblElsFee = 0 Then
            XC2 = "SignatureConfirmation"
            dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        End If
        CS32.SetVar "xDCR_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "ElectronicReturnReceipt"
        dblCsFee = 0
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "InsuredMail"
        dblCsFee = Val(CS32.GetVar("xINS_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        CS32.SetVar "xINS_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "RegisteredMail"
        dblCsFee = Val(CS32.GetVar("xREG_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        CS32.SetVar "xREG_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "RestrictedDelivery"
        dblCsFee = 0
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "ReturnReceipt"
        dblCsFee = Val(CS32.GetVar("xRTN_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        CS32.SetVar "xRTN_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        XC2 = "ReturnReceiptForMerchandise"
        dblCsFee = 0
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
           
        XC2 = "SpecialHandling"
        dblCsFee = Val(CS32.GetVar("xSHND_CHG"))
        dblElsFee = Val(XmlReadXPath(elsResponseXml, "/LabelRequestResponse/PostagePrice/Fees/" & XC2 & "/text()"))
        CS32.SetVar "xSHND_CHG", Str(dblElsFee, 8, 2)
        dblTotChg = dblTotChg - dblCsFee + dblElsFee
            
        CS32.SetVar "xTOT_CHG", Str(dblTotChg, 8, 2)
    End If
    
    KillStatus
    
    Dim sDirectory As String
    Dim sFileName As String
    Dim sFileExt As String
    Dim sSuffix As String
    
    sDirectory = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Directory", sLblType))
    If KiEmpty(sDirectory) Then
        sDirectory = elsDir & "Labels\"
    End If
    If Right(sDirectory, 1) <> "\" Then
        sDirectory = sDirectory & "\"
    End If
   
    'Get unique filename for label.
    sFileName = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Filename", sLblType))
    If Not KiEmpty(sFileName) Then
        sFileName = StrTran(sFileName, "&lt;", "<")
        sFileName = StrTran(sFileName, "&gt;", ">")
        sFileName = StrTran(sFileName, "&quot;", """")
    Else
        sFileName = "<CSFIELD name=""RECORDID"" />"
    End If
    Do While InStr(sFileName, "<CSFIELD") > 0
        XC1 = SubStr(sFileName, InStr(sFileName, "<CSFIELD"))
        XC1 = Left(XC1, InStr(XC1, ">"))
        XC2 = XmlReadXPathFromText((XC1), "/CSFIELD/@name")
        If Upper(XC2) = "ORD_CNT" Then
            XC3 = Str(Val(CS32.GetVar("xORD_CNT")) + 1)
        Else
            XC3 = CS32.GetVar("x" & XC2)
        End If
        sFileName = StrTran(sFileName, XC1, Alltrim(XC3))
    Loop
    
    sFileExt = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Extension", sLblType))
    If KiEmpty(sFileExt) Then
        sFileExt = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Format", sLblType))
    End If
    
    PopStatus "Endicia Label Server", "Decoding label data..."
    
    XC1 = "/LabelRequestResponse/Base64LabelImage"
    If KiEmpty(XmlReadXPath(elsResponseXml, XC1 & "/text()")) Then
        XC1 = "/LabelRequestResponse/Label/Image"
    End If
    XN2 = 1
    Do While True
        XC2 = Alltrim(XmlReadXPath(elsResponseXml, XC1 & "[" & Alltrim(Str(XN2)) & "]/text()"))
        If KiEmpty(XC2) Then
            Exit Do
        End If
        
        PopStatus "Endicia Label Server", "Decoding label data(" & Alltrim(Str(XN2)) & ")..."
        If logLvl >= 2 Then
            logTxt = "ELS: Decoding label " & Str(XN2)
            'logWrite
        End If
        
        'Save base64 data to temp file.
        fErase elsTmpDir & "els_label.b64"
        elsFileNum0 = FreeFile
        kiDebug "els_label.b64: " & elsFileNum0, ProjectDir() & "Debug.log", "ELS_Record()"
        Open elsTmpDir & "els_label.b64" For Output As #elsFileNum0
        Print #elsFileNum0, XC2
        Close #elsFileNum0
        
        sSuffix = ""
        If XN2 > 1 Then
            sSuffix = "-" & Alltrim(Str(XN2))
        End If
        
        XC3 = "<decode>" & _
            XmlWriteTag("base64file", elsTmpDir & "els_label.b64") & _
            XmlWriteTag("decodedfile", elsTmpDir & "els_label.tmp") & _
            XmlWriteTag("deleteoriginal", "true") & _
            "</decode>"
            
        fErase elsTmpDir & "Temp\Output\labeldecode.xml"
        fErase elsDir & "Labels\" & sFileName & sSuffix & "." & sFileExt
        
        elsFileNum0 = FreeFile
        kiDebug "labeldecode.xml: " & elsFileNum0, ProjectDir() & "Debug.log", "ELS_Record()"
        Open elsTmpDir & "Temp\labeldecode.xml" For Output As #elsFileNum0
        Print #elsFileNum0, XC3
        Close #elsFileNum0
        
        WinExec elsTmpDir & "ELS-LabelPrint.exe"
        
        XN3 = 0
        Do While XN3 < 200
            If fExist(elsTmpDir & "Temp\Output\labeldecode.xml") Then
                Exit Do
            End If
            Delay 0.05
            XN3 = XN3 + 1
        Loop

        fMove elsTmpDir & "els_label.tmp", sDirectory & sFileName & sSuffix & "." & sFileExt
        
        XN2 = XN2 + 1
    Loop
    
    KillStatus
End Function


Function ELS_PrintLabel() As Boolean
    ELS_PrintLabel = False

    Dim csIntCode As String
    csIntCode = CS32.GetVar("xxINTCODE")
    
    elsMailClass = XmlReadXPath(elsSettingsXml, "/ELS/MailClasses/MailClass[@intcode='" & csIntCode & "']/text()")
    If KiEmpty(elsMailClass) Then
        Exit Function
    End If
    
    Dim elsIsConsolidator As Boolean
    elsIsConsolidator = (Upper(XmlReadXPath(elsSettingsXml, "ELS/MailClasses/MailClass[@intcode='" & csIntCode & "']/@consolidator")) = "Y")
    
    Dim sLblType As String, sLblSubtype As String
    Dim sPrinter As String
    
    'Lookup packaging type.
    sMailpieceShape = CS32.GetVar("xINP_FLAG")
    sMailpieceShape = XmlReadXPath(elsSettingsXml, "/ELS/MailpieceShapes/MailpieceShape[@use_inp='" + sMailpieceShape + "']/text()")
    If KiEmpty(sMailpieceShape) Then
        sMailpieceShape = "Parcel"
    End If
    
    elsLblFormatXmlStr = ELS_GetLabelFormat(elsMailClass, sMailpieceShape)
    
    sLblType = ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Type")
    sLblSubtype = ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Subtype")
    
    PopStatus "Endicia Label Server", "Sending label to printer..."
    
    Dim sFileName As String
    Dim sFileExt As String
    
    'Get unique filename for label.
    sFileName = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Filename", sLblType))
    If Not KiEmpty(sFileName) Then
        sFileName = StrTran(sFileName, "&lt;", "<")
        sFileName = StrTran(sFileName, "&gt;", ">")
        sFileName = StrTran(sFileName, "&quot;", """")
    Else
        sFileName = "<CSFIELD name=""RECORDID"" />"
    End If
    Do While InStr(sFileName, "<CSFIELD") > 0
        XC1 = SubStr(sFileName, InStr(sFileName, "<CSFIELD"))
        XC1 = Left(XC1, InStr(XC1, ">"))
        XC2 = XmlReadXPathFromText((XC1), "/CSFIELD/@name")
        sFileName = StrTran(sFileName, XC1, Alltrim(CS32.GetVar("x" & XC2)))
    Loop
    
    sFileExt = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Extension", sLblType))
    If KiEmpty(sFileExt) Then
        sFileExt = Alltrim(ELS_GetLabelFormatSetting(elsLblFormatXmlStr, "Format", sLblType))
    End If
    
    elsStr1 = "//LabelFormat[@computername='" & Upper(Alltrim(ComputerName())) & "']/DirectPrinter/text()"
    sPrinter = XmlReadXPathFromText(elsLblFormatXmlStr, elsStr1)
    If KiEmpty(sPrinter) Then
        elsStr1 = "//LabelFormat[@cs-workstation='" & Upper(Alltrim(CS32.GetVar("xWORKSTATION"))) & "']/DirectPrinter/text()"
        sPrinter = XmlReadXPathFromText(elsLblFormatXmlStr, elsStr1)
    End If
    If KiEmpty(sPrinter) Then
        elsStr1 = "//LabelFormat[not(@cs-workstation) and not(@computername)]/DirectPrinter/text()"
        sPrinter = XmlReadXPathFromText(elsLblFormatXmlStr, elsStr1)
    End If
    If Not KiEmpty(sPrinter) Then
        XC3 = "<sendtoprinter>" & _
            XmlWriteTag("printername", sPrinter) & _
            XmlWriteTag("printfile", elsDir & "Labels\" & sFileName & "." & sFileExt) & _
            "</sendtoprinter>"
            
        fErase elsTmpDir & "Temp\Output\labelprint.xml"
        
        elsFileNum0 = FreeFile
        kiDebug "labelprint.xml: " & elsFileNum0, ProjectDir() & "Debug.log", "ELS_LabelPrint()"
        Open elsTmpDir & "Temp\labelprint.xml" For Output As #elsFileNum0
        Print #elsFileNum0, XC3
        Close #elsFileNum0
        
        WinExec elsTmpDir & "ELS-LabelPrint.exe /silent"
        
        XN3 = 0
        Do While XN3 < 200
            If fExist(elsTmpDir & "Temp\Output\labelprint.xml") Then
                Exit Do
            End If
            Delay 0.05
            XN3 = XN3 + 1
        Loop
    Else
        MsgBox "Printer not defined. Return label saved as:" & vbCrLf & elsDir & "Labels\" & sFileName & "." & sFileExt
    End If
    
    KillStatus
    ELS_PrintLabel = True
End Function

Function ELS_GetLabelFormat(ByVal sMailClass As String, ByVal sMailpieceShape As String) As String
    ELS_GetLabelFormat = ""
    
    Dim lblFormatList As MSXML2.IXMLDOMNodeList
    Dim lblFormat As MSXML2.IXMLDOMNode
    
    Dim match As Boolean
    
    Set lblFormatList = elsSettingsXml.selectNodes("/ELS/LabelFormats/LabelFormat")
    
    For Each lblFormat In lblFormatList
        Dim attr As MSXML2.IXMLDOMNamedNodeMap
                
        match = True
        Set attr = lblFormat.Attributes
        For i = 0 To attr.Length - 1
            If (SubToken(attr(i).baseName, 1, "-") = "cs") Then
                Dim sField As String
                Dim sValue As String
                
                sField = SubToken(attr(i).baseName, 2, "-")
                sValue = attr(i).Text
                
                If (Left(sValue, 3) = "in(") Then
                    sValue = SubStr(sValue, 4)
                    sValue = Left(sValue, Len(sValue) - 1)
                    
                    match = (InStr(sValue, CS32.GetVar("x" & sField)) > 0)
                Else
                    match = (CS32.GetVar("x" & sField) = sValue)
                End If
                If Not match Then Exit For
            ElseIf (attr(i).baseName = "computername") Then
                elsStr1 = ComputerName()
                match = (elsStr1 = attr(i).Text)
            End If
        Next
        
        If match Then
            Dim sLblForm As String, sLblType As String, sLblSubtype As String, sLblSubtypeForm
            Dim newNode As MSXML2.IXMLDOMElement
            
            elsStr1 = "/ELS/FormUsages/Form[@MailClass='" + sMailClass + "' and @MailpieceShape='" + sMailpieceShape + "']/text()"
            sLblForm = XmlReadXPath(elsSettingsXml, elsStr1)
            If KiEmpty(sLblForm) Then
                elsStr1 = "/ELS/FormUsages/Form[@MailClass='" + sMailClass + "' and not(@MailpieceShape)]/text()"
                sLblForm = XmlReadXPath(elsSettingsXml, elsStr1)
                If KiEmpty(sLblForm) Then
                    sLblForm = "Default"
                End If
            End If
            
            elsStr2 = "/ELS/LabelForms/LabelForm[@Name='" & sLblForm & "']"
            sLblType = XmlReadXPath(elsSettingsXml, elsStr2 & "/@Type")
            sLblSubtype = XmlReadXPath(elsSettingsXml, elsStr2 & "/@Subtype")
            sLblSubtypeForm = XmlReadXPath(elsSettingsXml, elsStr2 & "/@SubtypeForm")
            
            Set newNode = elsSettingsXml.createElement("SubtypeForm")
            newNode.Text = sLblSubtypeForm
            lblFormat.insertBefore newNode, lblFormat.firstChild
                
            Set newNode = elsSettingsXml.createElement("Subtype")
            newNode.Text = sLblSubtype
            lblFormat.insertBefore newNode, lblFormat.firstChild
            
            Set newNode = elsSettingsXml.createElement("Type")
            newNode.Text = sLblType
            lblFormat.insertBefore newNode, lblFormat.firstChild
            
            ELS_GetLabelFormat = lblFormat.Xml
            Exit For
        End If
    Next
End Function

Public Function ELS_GetLabelFormatSetting(ByVal sLblFormatXmlStr As String, ByVal sSetting As String, Optional ByVal sLblType As String = "default") As String
    Dim sXPath As String
    sXPath = "/LabelFormat/" & sSetting & "[not(@type) or @type='" & LCase(sLblType) & "']/text()"
    ELS_GetLabelFormatSetting = XmlReadXPathFromText(sLblFormatXmlStr, sXPath)
End Function



