Attribute VB_Name = "Xml"
Function ReadXPath(ByRef xmlDoc As MSXML2.DOMDocument60, strXPath As String) As String
    ReadXPath = ""
    If xmlDoc Is Nothing Then
        Exit Function
    End If
    
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    xmlDoc.setProperty "SelectionLanguage", "XPath"
    Set xmlNode = xmlDoc.selectSingleNode(strXPath)
    
    If Not (xmlNode Is Nothing) Then
        ReadXPath = xmlNode.Text
    End If
    Set xmlNode = Nothing
End Function
Function ReadXPathFromText(ByVal strXmlText As String, ByVal strXPath As String) As String
    Dim xmlDoc As MSXML2.DOMDocument60
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    Set xmlDoc = New MSXML2.DOMDocument60
    xmlDoc.loadXML strXmlText
    xmlDoc.setProperty "SelectionLanguage", "XPath"
    
    Set xmlNode = xmlDoc.selectSingleNode(strXPath)
    
    ReadXPathFromText = ""
    If Not (xmlNode Is Nothing) Then
        ReadXPathFromText = xmlNode.Text
    End If
    Set xmlNode = Nothing
End Function

Function WriteTag(ByVal strTagName As String, ByVal strValue As String) As String
    WriteTag = "<" & strTagName & ">" & XmlSafe(strValue) & "</" & strTagName & ">"
End Function


Function XmlSafe(strValue As String) As String
    XmlSafe = strValue
    
    XmlSafe = StrTran(XmlSafe, "&", "&amp;")
    XmlSafe = StrTran(XmlSafe, "<", "&lt;")
    XmlSafe = StrTran(XmlSafe, ">", "&gt;")
    XmlSafe = StrTran(XmlSafe, """", "&quot;")
End Function

